% 1D Monte-Carlo simulation of diffusion from a constant concentration
% source at x=0, 

clear;
clc
X=100; % system length
x=0:X; % vector of positions in x-direction
T=500; % number of time steps jumps
n=zeros(1,X+1);
N=50; % number of particles at the source
n(1)=N;
n(2)=N;
m=zeros(1,X+1);
for i=1:T
    for j=2:X
        if n(j)>0
            for l=1:n(j)
                r=rand;   % create a random number 0<rand<1
                if r < .5
                    m(j-1)=m(j-1)+1;                    
                else
                    m(j+1)=m(j+1)+1;
                end;
            end;
        end;
    end;
    m(1)=N;
    m(2)=N;
    m(end)=0;
    n=m;
    m=zeros(1,X+1);
    nn=n/N;
    if mod(i,100)==0
        plot(x,nn,'.'), axis([0 X 0 1.5]); legend(['data ',num2str(i)],0); pause(0.001);
    end
end;
D=0.5;
c = 1-erf(x/(2*(D*T)^(1/2)));
plot(x,nn,'.',x,c); axis([0 X 0 1.5]); legend('MC','Fitting',0);

% nf=nn;
% xf=x;
% a=0;
% for i=1:size(n,2)
%     if nf(i)==0
%        a(end+1)=i;        
%     end;
% end; 
% a(1)=[];
% nf(a)=[];
% xf(a)=[];
% p=polyfit(xf,erfinv(1-nf),1);
% plot(x,nn,'.',x,(1-erf(x*p(1)+p(2)))); axis([0 X 0 1.5]); legend('MCsim','Fitting',0);
% text(.1*X, 1.2,['Time=',num2str(T),'; Fitting =1-erf(',num2str(p(1)),'*x); D=',num2str(1/(4*T*p(1).^2))]);
